# Chapter 4 of Introduction to Data Science for Business
#


# An initial comment should describe
# the function.
myFunction <- function(myArg) {
  # Comments inside the function
  # are helpful. Indent everything
  # inside the function.
  cat("myArg is: ", myArg, "\n")
    
  # Arguments can be used inside
  # the function. Many functions
  # return a value.
  return(TRUE)
}

myFunction(123)

# This won't work yet because we have not run our function
# to make it known to R.
colNameSort(mtcars)

# Create a function to sort a data frame's columns
# alphabetically by column name
colNameSort <- function(inputDF) {
}

colNameSort(mtcars)

# Create a function to sort a data frame's columns
# alphabetically by column name
colNameSort <- function(inputDF) {
  nameList <- colnames(inputDF) # What are the names?
  cat(nameList)
}

colNameSort(mtcars)

# Create a function to sort a data frame's columns
# alphabetically by column name
colNameSort <- function(inputDF) {
  nameList <- colnames(inputDF) # What are the names?
  nameList <- sort(nameList)
  cat(nameList)
}

colNameSort(mtcars)


# Create a function to sort a data frame's columns
# alphabetically by column name
colNameSort <- function(inputDF) {
  nameList <- colnames(inputDF) # What are the names?
  nameList <- sort(nameList)
  outputDF <- inputDF[nameList]
  cat(colnames(outputDF))
}

colNameSort(mtcars)


# Create a function to sort a data frame's columns
# alphabetically by column name
colNameSort <- function(inputDF) {
  nameList <- colnames(inputDF) # What are the names?
  nameList <- sort(nameList)
  outputDF <- inputDF[nameList]
  return(outputDF)
}

alphaMtcars <- colNameSort(mtcars)
str(alphaMtcars)


#defensive coding
colNameSort(Titanic)

# Create a function to sort a data frame's columns
# alphabetically by column name
colNameSort <- function(inputDF) {
  
  if (is.data.frame(inputDF)) {
    nameList <- colnames(inputDF) # What are the names?
    nameList <- sort(nameList)
    outputDF <- inputDF[nameList]
    return(outputDF)
  } else {
    warning("Please provide a dataframe as input to this function.\n")
    return(NULL)
  }
}

colNameSort(Titanic)


#Installing packages
library(dplyr)
colNameSort <- function(inputDF) {
  inputDF %>% select(sort(names(.)))
}

##########################
# case study
##########################

# CalcNPS function - calculate a net promoter score
# ltr - a vector of likliehood-to-recommend values
# neutral - the range, below which someone
# is considered a detractor and above which
# some is consider a promoter (default is 7 to 8)
CalcNPS <- function(ltr, neutral=c(7,8)) {
  
  #create a new vector with just the promoters
  #then calculate the length of the promoters vector
  promoters <- ltr[ltr > max(neutral)]
  numPromoters <- length(promoters)
  
  #calculate the number of detractors by summing the 
  #  elements that are less than 7
  detractorsTrueFalse <- ltr < min(neutral)
  numDetractors <- sum(detractorsTrueFalse)
  
  #calculate NPS, based on the length of ltr 
  #  and the number of promotors and detractors
  total <- length(ltr)
  nps <- (numPromoters/total - 
            numDetractors/total)*100
  
  #return the NPS value
  return(nps)
}

#Now test the function using a test vector
ltr <- c(9,8,3,9,7,8,9,6,7,8,9)
CalcNPS(ltr)

library(readr)
smallSurvey <- read_csv("smallSurvey.csv")

#remove the NAs from the LTR column
smallSurvey <- filter(smallSurvey, !is.na(LTR))

#The mean Likelihood.to.recommend by Type.of.Travel 
smallSurvey %>%
  group_by(Type.of.Travel) %>%
  summarize(mean=mean(LTR), count=n()) 

#What is the overall NPS?
CalcNPS(smallSurvey$LTR)

#The mean Likelihood.to.recommend by Type.of.Travel 
smallSurvey %>%
  group_by(Type.of.Travel) %>%
  summarize(nps=CalcNPS(LTR), count=n())

